#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}

%define		sname		smmsp

%define		stdir		%{_localstatedir}/log/mail
%define		spooldir	%{_localstatedir}/spool/%{name}
%define		maildir		%{_sysconfdir}/mail
%define		sendmailcf	%{_datadir}/sendmail-cf

%global		_milter		milter-devel
#-----------------------------------------------------------------------------
Name		:	sendmail
Version		:	8.16.1
Release		:	16.2.0.rel%{?dist}
Summary		:	A proved Mail Transport Agent (MTA)
Group		:	System Environment/Daemons

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	Sendmail
URL		:	ftp://ftp.sendmail.org/pub/sendmail

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	openldap-devel
BuildRequires	:	libdb-devel

Requires	:	chkconfig, shadow
Requires	:	libddb
Requires	:	m4
Requires	:	openldap-devel
Requires	:	procmail
#-----------------------------------------------------------------------------
%description
The Sendmail program is a very widely used Mail Transport Agent (MTA).
MTAs send mail from one machine to another. Sendmail is not a client
program, which you use to read your email. Sendmail is a
behind-the-scenes program which actually moves your email over
networks or the Internet to where you want it to go.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc CACerts FAQ KNOWNBUGS PGPKEYS README RELEASE_NOTES
%license LICENSE
%attr (0754,root,root) %{_sysconfdir}/rc.d/init.d/%{name}
%config (noreplace) %attr (0444,root,root) %{maildir}/%{name}.mc
%config (noreplace) %attr (0444,root,root) %{maildir}/submit.mc
%attr (0555,root,root) %dir %{maildir}
%attr (0444,root,root) %{maildir}/submit.cf
%attr (0555,root,root) %{maildir}/mctocf
%{maildir}/helpfile
%{maildir}/statistics
%{_bindir}/hoststat
%{_bindir}/newaliases
%{_bindir}/purgestat
%{_bindir}/mailq
%attr (0555,root,root) %{_bindir}/vacation
%attr (2555,root,%{sname}) %{_sbindir}/%{name}
%attr (0555,root,root) %{_sbindir}/editmap
%attr (0555,root,root) %{_sbindir}/mailstats
%attr (0555,root,root) %{_sbindir}/makemap
%attr (0555,root,root) %{_sbindir}/praliases
%attr (0555,root,root) %{_sbindir}/smrsh
%attr (0770,%{sname},%{sname}) %dir %{spooldir}/clientmqueue
%attr (0700,root,root) %dir %{spooldir}/mqueue
%{_mandir}/man1/*.1.gz
%{_mandir}/man5/*.5.gz
%{_mandir}/man8/*.8.gz
%{sendmailcf}/README
%{sendmailcf}/%{name}.schema
%{sendmailcf}/cf/Build
%{sendmailcf}/cf/Makefile
%{sendmailcf}/cf/README
%{sendmailcf}/cf/*.{mc,cf}
%{sendmailcf}/{domain,feature,hack,m4,mailer,ostype,siteconfig}/*.m4
%{sendmailcf}/sh/makeinfo.sh

#-----------------------------------------------------------------------------
%pre
if [ "$1" = 1 ]; then
  /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{sname}

  /usr/sbin/useradd 				\
	-r					\
	-c "Sendmail Daemon"			\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{sname}				\
	-s /bin/false				\
	-d /dev/null				\
	%{sname}
  fi

%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del %{name}
  /usr/sbin/userdel %{sname}
  /usr/sbin/groupdel %{sname}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi


%post
if [ "$1" = 1 ]; then
  (
  cd %{maildir}
  echo $(hostname) > local-host-names
  touch aliases.db
  chmod 0644 aliases.db
# lets say /etc/aliases is not existing
  cat > aliases << "EOF"
#----------------------------
#done by sendmail rpm installation
postmaster: root
MAILER-DAEMON: root
#----------------------------
EOF
  # By the way is /etc/aliases existing?
  if [ -f %{_sysconfdir}/aliases ] ; then
    cp -af %{_sysconfdir}/aliases %{_sysconfdir}/mail
    fi
  )
  fi
#create the sendmail statistic file
touch %{spooldir}/statistics

(
cd %{maildir}
#creating/updating sendmail configuration files
for conffile in %{name} submit
  do
  %{__rm} -fr  $conffile.cf
  ./mctocf $conffile
  chmod 0444 $conffile.cf
  done
)
%{_bindir}/newaliases > /dev/null 2>&1
/sbin/chkconfig --add %{name}
%{_sysconfdir}/rc.d/init.d/%{name} condrestart > /dev/null 2>&1 || :

#=============================================================================
%package -n 		%{_milter}
Summary		:	The sendmail milter library


#-----------------------------------------------------------------------------
%description -n		%{_milter}
The sendmail Mail Filter API (Milter) is designed to allow third-party
programs access to mail messages as they are being processed in order to
filter meta-information and content.
 
This package includes the milter static library.

#-----------------------------------------------------------------------------
%files -n		%{_milter}
%{_includedir}/libmilter/*.h
%{_libdir}/libmilter.a
%{_datadir}/licenses/%{_milter}-%{version}/LICENSE

#=============================================================================
%prep
%setup -q 

#-----------------------------------------------------------------------------
#building application
%build

tar xf %{SOURCE1}

cat >> devtools/Site/site.config.m4 << "EOF"
APPENDDEF(\`confENVDEF',`-DNEWDB -DSTARTTLS -DSASL -DLDAPMAP')
APPENDDEF(\`confLIBS', `-lssl -lcrypto -lsasl2 -lldap -llber -ldb -lresolv')
APPENDDEF(\`confINCDIRS', `-I /usr/include -I/usr/include/sasl')
APPENDDEF(\`conf_libmilter_ENVDEF',\`${CPPFLAGS} ${CFLAGS}')
APPENDDEF(\`conf_libmilter_ENVDEF',\`-D_FFR_WORKERS_POOL=1 -DMIN_WORKERS=4')
APPENDDEF(\`conf_libmilter_ENVDEF',\`-DNETINET6=1')
APPENDDEF(\`conf_libmilter_ENVDEF',\`-fPIC')
EOF

sed -i							\
  -e 's|/usr/man/man|%{_mandir}/man|'			\
    devtools/OS/Linux

#building application
%{__make}

pushd cf/cf
cp generic-linux.mc %{name}.mc
sh Build %{name}.cf
popd

#building libmilter as static library
pushd libmilter
sh Build
popd

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

#defining builder name and group
nameuser=`id -nu`
namegroup=`id -ng`

domake() {
	make $@ \
		DESTDIR=%{buildroot}			\
		LIBDIR=%{_libdir}			\
		MANROOT=%{_mandir}/man			\
		LIBMODE=0755				\
		INCMODE=0644				\
		SBINOWN=${nameuser} SBINGRP=${namegroup}\
		UBINOWN=${nameuser} UBINGRP=${namegroup}\
		MANOWN=${nameuser} MANGRP=${namegroup}	\
		INCOWN=${nameuser} INCGRP=${namegroup}	\
		LIBOWN=${nameuser} LIBGRP=${namegroup}	\
		GBINOWN=${nameuser} GBINGRP=${namegroup}\
		CFMODE=0644				\
		CFOWN=${nameuser} CFGRP=${namegroup}	\
		MSPQOWN=${nameuser}
}

#creating needed directory
for dirname in						\
	 %{_bindir}					\
	 %{_sbindir}					\
	 %{_includedir}/libmilter			\
	 %{_libdir}					\
	 %{_mandir}/man{1,5,8}				\
	 %{stdir}					\
	 %{spooldir}/{mqueue,clientmqueue}		\
	 %{_defaultdocdir}/%{name}-%{version}		\
	 %{sendmailcf}
  do
  %{__mkdir_p} %{buildroot}$dirname
  done

#installing core application
OBJDIR=obj.$(uname -s).$(uname -r).$(uname -m)
domake install -C $OBJDIR/editmap
domake install -C $OBJDIR/libsm
domake install -C $OBJDIR/libsmdb
domake install -C $OBJDIR/libsmutil
domake install -C $OBJDIR/mail.local
domake install -C $OBJDIR/mailstats
domake install -C $OBJDIR/makemap
domake install -C $OBJDIR/praliases
domake install -C $OBJDIR/rmail
domake install -C $OBJDIR/sendmail
domake install -C $OBJDIR/smrsh
domake install -C $OBJDIR/vacation

# install configuration file
%{__cp} -a						\
	cf/cf/{%{name},submit}.mc			\
	%{buildroot}%{maildir}

#adjusting directories to real directories
(
echo "define(\`STATUS_FILE',\`%{spooldir}/statistics')dnl"
echo "define(\`QUEUE_DIR',\`%{spooldir}/mqueue')dnl"
) >> %{buildroot}%{maildir}/%{name}.mc
(
echo "define(\`QUEUE_DIR',\`%{spooldir}/clientmqueue')dnl"
) >> %{buildroot}%{maildir}/submit.mc

# install manual
for manpage in						\
	sendmail					\
	editmap						\
	mailstats					\
	makemap						\
	praliases					\
	smrsh
  do
  install -m0644					\
	  $manpage/*.8					\
	  %{buildroot}%{_mandir}/man8
  done

install -m0644 sendmail/aliases.5    %{buildroot}%{_mandir}/man5
install -m0644 sendmail/mailq.1      %{buildroot}%{_mandir}/man1
install -m0644 sendmail/newaliases.1 %{buildroot}%{_mandir}/man1
install -m0644 vacation/vacation.1   %{buildroot}%{_mandir}/man1

# install the cf files for sendmail-cf components.
%{__cp} -a						\
	cf/*						\
	%{buildroot}%{sendmailcf}

#installing sendmail daemon starting/stopping script
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} -a 						\
	%{name}-ok_addon/%{name}			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

# fix permissions to allow debuginfo extraction and stripping
chmod 755 %{buildroot}%{_sbindir}/{editmap,mailstats,makemap}
chmod 755 %{buildroot}%{_sbindir}/{praliases,sendmail,smrsh}
chmod 755 %{buildroot}%{_bindir}/vacation

cat > %{buildroot}%{maildir}/mctocf << "EOF"
#!/bin/sh
#---------------------------------------------
#to convert sendmail $1.mc to $1.cf
#---------------------------------------------
m4 %{sendmailcf}/m4/cf.m4 $1.mc > $1.cf
#---------------------------------------------
exit 
EOF

pushd libmilter
./Build							\
	INCMODE=0644					\
	INCOWN=${nameuser} INCGRP=${namegroup}		\
	LIBMODE=0755					\
	LIBOWN=${nameuser} LIBGRP=${namegroup}		\
	DESTDIR=%{buildroot}				\
	install
install -Dm644						\
	../LICENSE					\
	%{buildroot}%{_datadir}/licenses/%{_milter}-%{version}/LICENSE
popd

#-----------------------------------------------------------------------------
%changelog
